<?php
// +-----------------------------------------------------------------------+
// | FacebookPlug - a Piwigo Plugin                                        |
// | Copyright (C) 2010-2011 Ruben ARNAUD - rub@piwigo.org                 |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

if (!defined('PHPWG_ROOT_PATH'))
{
  die('Hacking attempt!');
}

function fbp_get_fb_locale()
{
  global $user;

  // Array compute by plugins/FacebookPlug/tools/check_language.php script
  $valid_fb_locales = array ( 0 => 'ar_AR', 1 => 'ca_ES', 2 => 'cs_CZ', 3 => 'da_DK', 4 => 'de_DE', 5 => 'es_ES', 6 => 'fa_IR', 7 => 'fr_CA', 8 => 'fr_FR', 9 => 'he_IL', 10 => 'hr_HR', 11 => 'hu_HU', 12 => 'it_IT', 13 => 'ja_JP', 14 => 'ka_GE', 15 => 'lv_LV', 16 => 'mk_MK', 17 => 'nl_NL', 18 => 'pl_PL', 19 => 'pt_BR', 20 => 'pt_PT', 21 => 'ro_RO', 22 => 'ru_RU', 23 => 'sk_SK', 24 => 'sr_RS', 25 => 'sv_SE', 26 => 'tr_TR', 27 => 'vi_VN', 28 => 'zh_CN', );

  // User language
  $locale = $user['language'];
  if (! in_array($locale, $valid_fb_locales))
  {
    $code_lang = substr($locale, 0, 2);
    // Compose a locale
    $locale = $code_lang.'_'.strtoupper($code_lang);
    if (! in_array($locale, $valid_fb_locales))
    {
      // Search a locale
      foreach ($valid_fb_locales as $valid_fb_locale)
      {
        if ($code_lang == substr($valid_fb_locale, 0, 2))
        {
          return $valid_fb_locale;
        }
      }
      // default locale
      $locale = 'en_US';
    }
  }

  return $locale;
}

function fbp_header($content, &$smarty)
{
  // replace tag html
  $search = '<html ';
  $replacement = '<html xmlns:fb="http://www.facebook.com/2008/fbml" ';

  //~ $content = preg_replace('#'.$search.'#', $replacement, $content);
  return preg_replace('#'.$search.'#', $replacement, $content);
  //~ $fbp_content = file_get_contents(FBP_DIR.'/tpl/init.fb.tpl');

  //~ $search = '<div id="the_page">';
  //~ return preg_replace('#'.$search.'#', $fbp_content.$search, $content);
}

function fbp_init()
{
  global $template, $conf, $user, $page;

  // Lingua
  load_language('common.lang', FBP_DIR.'/');

  // Get init facebook
  $page['fbp']['do_facebook_init'] = trigger_event('fbp_do_facebook_init', $conf['fbp']['force_facebook_init']);
  if ($page['fbp']['do_facebook_init'])
  {
    // define ID
    $template->assign('FACEBOOK_APP_ID', (is_numeric($conf['fbp']['facebook_app_id']) ? $conf['fbp']['facebook_app_id'] : FACEBOOK_APP_ID));
    // define language
    $template->assign('FACEBOOK_LOCALE', fbp_get_fb_locale());
    $template->assign('FBP_PATH', FBP_PATH);
    $template->assign('FBP_SCRIPT_BASENAME', script_basename());
    $template->assign('fbp', $conf['fbp']);
    //~ $template->smarty->register_modifier('boolean_to_string', 'boolean_to_string');
  }
}

function fbp_loc_end_page_header()
{
  global $template, $conf, $user, $page;

  if ($page['fbp']['do_facebook_init'])
  {
    // set prefilter
    $template->set_prefilter('header', 'fbp_header');

    if (empty($page['fbp']['url']))
    {
      $page['fbp']['url'] = get_absolute_root_url().script_basename();
      if ($conf['php_extension_in_urls'])
      {
        $page['fbp']['url'] .= '.php';
      }
    }

    $template->assign('fbp_page', $page['fbp']);

    $template->set_filename('fbp_init.fb', FBP_DIR.'/tpl/init.fb.tpl');
    $template->append('head_elements', $template->parse('fbp_init.fb', true));

    if (
        (script_basename() == 'index')
        and
        ($conf['fbp']['social_plugin_activity_feed']['enabled'] or $conf['fbp']['social_plugin_like_box']['enabled'])
        )
    {
      $template->block_html_head('', '<link rel="stylesheet" type="text/css" href="'.FBP_PATH.'/css/fbp.css">', $smarty, $repeat);
    }
  }
}

function fbp_do_facebook_init($do_it)
{
  global $conf;

  return 
    $do_it
  or
    (
      (
        (script_basename() == 'picture')
        and
        ($conf['fbp']['social_plugin_like_button']['enabled'] or $conf['fbp']['social_plugin_facepile']['enabled'] or $conf['fbp']['social_plugin_comments']['enabled'] or $conf['fbp']['share_picture'] or $conf['fbp']['upload_picture'])
      )
      or
      (
        (script_basename() == 'index')
        and
        ($conf['fbp']['social_plugin_activity_feed']['enabled'] or $conf['fbp']['social_plugin_like_box']['enabled'] or $conf['fbp']['share_album'])
      )
      or
      (
        (script_basename() == 'admin')
        and
        (isset($_GET['page']) and $_GET['page'] == 'plugin')
        and
        (isset($_GET['section']) and strtok($_GET['section'], '/') == 'FacebookPlug')
      )
    )
  ;
}

function fbp_is_facebook_ip()
{
  foreach (array(
    FBP_IP_FB, 
    //~ '127.0',
      ) as $ip_fb)
  {
    if (preg_match('/'.$ip_fb. '/', $_SERVER["REMOTE_ADDR"]))
    {
      return true;
    }
  }
  return false;
}

function ftp_loc_end_section_init()
{
  global $conf, $page, $user;

  // No restristion for facebook user
  if (
      $page['fbp']['do_facebook_init']
      and 
      is_a_guest()
      and
      $conf['fbp']['allow_fb_access_private_page']
      and
      fbp_is_facebook_ip()
    )
  {
    global $user, $header_notes;

    // Notes
    $header_notes[] = 'Facebook robot detected, guest can access private page';
    // Allow guest access
    $conf['guest_access'] = true;
    // No forbidden categorie
    $user['forbidden_categories'] = '';
    $user['level'] = max($conf['available_permission_levels']);
    switch (script_basename())
    {
      case 'picture':
        if (isset($page['image_id']))
        {
          $page['rank_of'][$page['image_id']] = 0;
          $page['items'] = array_flip($page['rank_of']);
        }
        break;
      case 'index':
        if (isset($page['category']['representative_picture_id']))
        {
          fbp_loc_begin_index_category_thumbnails(array($page['category']));
        }
      break;
    }
    //~ else if $page['category']['id']
  }
}

add_event_handler('init', 'fbp_init');
add_event_handler('loc_end_page_header', 'fbp_loc_end_page_header');
add_event_handler('fbp_do_facebook_init', 'fbp_do_facebook_init');
add_event_handler('loc_end_section_init', 'ftp_loc_end_section_init');

?>
